c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine init(c2,Rgp,over,rid,band_sigma,band_k,
     &     sens_P,sens_T,sens_x,
     &     band_dsigma_dP,band_dsigma_dT,band_dsigma_dx,
     &     band_dk_dP,band_dk_dT,band_dk_dx)
      implicit none
      include 'parameters.inc'
      include 'max.inc'
      double precision c2,Rgp
      logical rid
      integer over,ik,mol,imol
      logical sens_P,sens_T,sens_x
      character*(Nchar_mx) command
      double precision band_sigma(1:Nkmx,0:Nmol_max)
      double precision band_k(1:Nkmx,0:Nmol_max)
      double precision band_dsigma_dP(1:Nkmx)
      double precision band_dsigma_dT(1:Nkmx)
      double precision band_dsigma_dx(1:Nkmx,1:Nmol_max)
      double precision band_dk_dP(1:Nkmx)
      double precision band_dk_dT(1:Nkmx)
      double precision band_dk_dx(1:Nkmx,1:Nmol_max)
      integer strlen
      character*(Nchar_mx) label
      label='subroutine init'

      c2=hPl*c0/kBz*1.D+2       ! K.cm
      Rgp=22.4D-3/(273.15D+0)   ! atm.m/(mol.K)

      if ((over.eq.1).or.((over.eq.0).and.(.not.rid))) then
         call write_backup(0,0,0,1,0,1)
         command='rm -f ./status.txt'
         call exec(command)
         command='rm -f ./results/smesh.log_*'
         call exec(command)
         command='rm -f ./results/errors.log_*'
         call exec(command)
         command='rm -f ./optimizations/k*'
         call exec(command)
         command='rm -f ./optimizations/slimits*'
         call exec(command)
      endif

      do ik=1,Nkmx
         do imol=0,Nmol_max
            band_sigma(ik,imol)=0.0D+0
            band_k(ik,imol)=0.0D+0
         enddo                  ! imol
         if (sens_P) then
            band_dsigma_dP(ik)=0.0D+0
            band_dk_dP(ik)=0.0D+0
         endif
         if (sens_T) then
            band_dsigma_dT(ik)=0.0D+0
            band_dk_dT(ik)=0.0D+0
         endif
         if (sens_x) then
            do mol=1,Nmol_max
               band_dsigma_dx(ik,mol)=0.0D+0
               band_dk_dx(ik,mol)=0.0D+0
            enddo ! mol
         endif
      enddo

      return
      end
