c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine read_options(sdis,custom_db,htv,htsd_co2,htsd_h2o,dr,
     &     nis,line_profile,usl,sl_choice,slwr,slam,slas,
     &     ucia,ciac,ciawr,ciatr,est,pct,
     &     rid,sens_T,sens_P,sens_x,
     &     uaal,uanb,sda,bslal,ltr,dorg,rbc,tfl,rl)
      implicit none
      include 'max.inc'
c     I/O
      integer i
      integer sdis
      logical custom_db
      integer htv
      integer htsd_co2
      integer htsd_h2o
      integer dr
      integer nis
      integer line_profile
      logical usl
      integer sl_choice
      logical slwr
      logical slam
      logical slas
      logical ucia
      integer ciac
      logical ciawr
      logical ciatr
      integer est
      logical pct
      logical rid
      logical sens_T
      logical sens_P
      logical sens_x
      integer uaal
      integer uanb
      integer sda
      integer bslal
      logical ltr
      integer dorg
      logical rbc
      logical tfl
      logical rl
c     temp
c     label
      integer strlen
      character*(Nchar_mx) label
      label='subroutine read_options'

      open(14,file='./options.in')
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Narrowband discretization
c     *******************************************************
      read(14,*) sdis
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Choice of spectrocopic database
c     *******************************************************
      read(14,*) custom_db
      read(14,*)
      read(14,*) htv
      if ((htv.ne.2004).and.(htv.ne.2008).and.(htv.ne.2012)) then
         write(*,*) 'Incorrect value is "options.in":'
         write(*,*) 'version of the HITRAN database'
         stop
      endif
      read(14,*) 
      read(14,*) htsd_co2
      read(14,*) 
      read(14,*) htsd_h2o
      read(14,*) 
      read(14,*) dr
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Composition
c     *******************************************************
      read(14,*) nis
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Line profiles
c     *******************************************************
      read(14,*) line_profile
      read(14,*) 
      read(14,*) usl
      read(14,*) 
      read(14,*) sl_choice
      read(14,*) 
      read(14,*) slwr
      read(14,*) 
      read(14,*) slam
      read(14,*) 
      read(14,*) slas
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Collision-Induced absorption
c     *******************************************************
      read(14,*) ucia
      read(14,*) 
      read(14,*) ciac
      read(14,*) 
      read(14,*) ciawr
      read(14,*) 
      read(14,*) ciatr
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Code behavior
c     *******************************************************
      read(14,*) pct
      read(14,*) 
      read(14,*) rid
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Sensitivities
c     *******************************************************
      read(14,*) sens_T
      read(14,*) 
      read(14,*) sens_P
      read(14,*) 
      read(14,*) sens_x
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Levels and narrowbands limits (see "data.in" for numerical values associated)
c     *******************************************************
      read(14,*) uaal
      read(14,*) 
      read(14,*) uanb
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Spectral discretization algorithm
c     *******************************************************
      read(14,*) sda
      read(14,*)
      read(14,*) bslal
      do i=1,7
         read(14,*)
      enddo
c     *******************************************************
c     Line truncation
c     *******************************************************
      read(14,*) ltr
      read(14,*)
      read(14,*) dorg
      read(14,*)
      read(14,*) rbc
      read(14,*)
      read(14,*) tfl
      read(14,*)
      read(14,*) rl
      
      close(14)

      est=1

      return
      end
