c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine set_iso_abundance(abundances,Nmol,mol_niso,i,
     &     iso_abundance)
      implicit none
c     
c     Purpose: to set iso_abundance array according to the current atmospheric level
c
c     Inputs:
c       + abundances(i,mol,iso) is the abundance of isotope 'iso' for molecule 'mol', at level 'i'
c       + Nmol: number of molecules in the gaz mix
c       + mol_niso: number of isotopes for each molecule
c       + i: current atmospheric level
c
c     Outputs:
c       + iso_abundance: abundances of isotopes for each molecule
c
      include 'max.inc'
      integer mol,iso
      integer Nmol,i
      integer mol_niso(1:Nmol_max)
      double precision abundances(1:Nmax,1:Nmol_max,1:Niso_max)
      double precision iso_abundance(1:Nmol_max,1:Niso_max)
c     label
      integer strlen
      character*(Nchar_mx) label
      label='subroutine set_iso_abundance'

      do mol=1,Nmol
         do iso=1,mol_niso(mol)
            iso_abundance(mol,iso)=abundances(i,mol,iso)
c            iso_abundance(mol,iso)=1.0D+0
         enddo                  ! iso
      enddo                     ! mol

      return
      end
